package edu.wpi.banmqp.shimmer.commands.learned;

import de.congrace.exp4j.Calculable;
import edu.wpi.banmqp.shimmer.data.CalculatorFactory;

public class ReturnMapping {
	private int sizeInBytes;
	private int typeID;
	private String name;
	private Calculable conversionExpression;
	private String units;
	
	
	public ReturnMapping(int sizeInBytes, int typeID, String name,
			String conversionExpression, String units) {
		super();
		this.sizeInBytes = sizeInBytes;
		this.typeID = typeID;
		this.name = name;
		this.conversionExpression = CalculatorFactory.generate(conversionExpression);
		this.units = units;
	}


	/**
	 * @return the sizeInBytes
	 */
	public int getSizeInBytes() {
		return sizeInBytes;
	}


	/**
	 * @return the typeID
	 */
	public int getTypeID() {
		return typeID;
	}


	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}


	/**
	 * @return the conversionExpression
	 */
	public Calculable getConversionExpression() {
		return conversionExpression;
	}


	/**
	 * @return the units
	 */
	public String getUnits() {
		return units;
	}
	

}
