package edu.wpi.banmqp.shimmer.data;

import de.congrace.exp4j.Calculable;
import de.congrace.exp4j.ExpressionBuilder;
import de.congrace.exp4j.UnknownFunctionException;
import de.congrace.exp4j.UnparsableExpressionException;
import edu.wpi.banmqp.util.BANLog;

public abstract class CalculatorFactory {

	public static Calculable generate(String expression){
		try{
			Calculable calc = new ExpressionBuilder(expression).withVariableNames("x").build();
			return calc;
		} catch (UnparsableExpressionException e){
			BANLog.e("CalculatorFactory", "Expression " + expression + " could not be parsed");
			return null;
		} catch (UnknownFunctionException e) {
			BANLog.e("CalculatorFactory", "Unknown function in " + expression);
			return null;
		}




	}

}
