package edu.wpi.banmqp.shimmer.data;

import de.congrace.exp4j.Calculable;

public class ValueMapping {
	private int sizeInBytes;
	private int typeID;
	private String name;
	private String sConversionExpression;
	private Calculable conversionExpression;
	private String units;
	
	
	public ValueMapping(int sizeInBytes, int typeID, String name,
			String conversionExpression, String units) {
		super();
		this.sizeInBytes = sizeInBytes;
		this.typeID = typeID;
		this.name = name;
		sConversionExpression = conversionExpression;
		this.conversionExpression = CalculatorFactory.generate(conversionExpression);
		this.units = units;
	}


	/**
	 * @return the sizeInBytes
	 */
	public int getSizeInBytes() {
		return sizeInBytes;
	}


	/**
	 * @return the typeID
	 */
	public int getTypeID() {
		return typeID;
	}


	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}


	/**
	 * @return the conversionExpression
	 */
	public Calculable getConversionExpression() {
		return conversionExpression;
	}


	/**
	 * @return the units
	 */
	public String getUnits() {
		return units;
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime
				* result
				+ ((sConversionExpression == null) ? 0 : sConversionExpression
						.hashCode());
		result = prime * result + sizeInBytes;
		result = prime * result + typeID;
		result = prime * result + ((units == null) ? 0 : units.hashCode());
		return result;
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ValueMapping other = (ValueMapping) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (sConversionExpression == null) {
			if (other.sConversionExpression != null)
				return false;
		} else if (!sConversionExpression.equals(other.sConversionExpression))
			return false;
		if (sizeInBytes != other.sizeInBytes)
			return false;
		if (typeID != other.typeID)
			return false;
		if (units == null) {
			if (other.units != null)
				return false;
		} else if (!units.equals(other.units))
			return false;
		return true;
	}
	
	
	

}
