package edu.wpi.banmqp.shimmer.sensor;

import java.util.ArrayList;

import edu.wpi.banmqp.shimmer.IShimmer;
import edu.wpi.banmqp.shimmer.commands.learned.ILearnedCommand;
import edu.wpi.banmqp.shimmer.data.ValueMapping;

public class Sensor implements ISensor {
	String sensorName;
	ArrayList<ValueMapping> valueMappings;
	ArrayList<ILearnedCommand> learnedCommands;
	int ID;
	IShimmer mote;

	public Sensor(int ID, String name, IShimmer mote) {
		sensorName = name;
		this.ID = ID;
		valueMappings = new ArrayList<ValueMapping>();
		this.mote = mote;
	}
	
	@Override
	public int getID(){
		return ID;
	}
	
	@Override
	public void setValueMappings(ArrayList<ValueMapping> vm){
		valueMappings = vm;
	}
	
	/**
	 * @return the learnedCommands
	 */
	@Override
	public ArrayList<ILearnedCommand> getLearnedCommands() {
		return learnedCommands;
	}

	/**
	 * @param learnedCommands the learnedCommands to set
	 */
	@Override
	public void setLearnedCommands(ArrayList<ILearnedCommand> learnedCommands) {
		this.learnedCommands = learnedCommands;
	}

	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return sensorName;
	}

	@Override
	public ILearnedCommand getCommandById(int id) {
		for(int i = 0; i < learnedCommands.size(); i++){
			if(learnedCommands.get(i).getID() == id){
				return learnedCommands.get(i);
			}
		}
		return null;
	}

	@Override
	public ArrayList<ValueMapping> getValueMappings() {
		return valueMappings;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ID;
		result = prime * result
				+ ((learnedCommands == null) ? 0 : learnedCommands.hashCode());
		result = prime * result
				+ ((sensorName == null) ? 0 : sensorName.hashCode());
		result = prime * result
				+ ((valueMappings == null) ? 0 : valueMappings.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Sensor other = (Sensor) obj;
		if (ID != other.ID)
			return false;
		if (learnedCommands == null) {
			if (other.learnedCommands != null)
				return false;
		} else if (!learnedCommands.equals(other.learnedCommands))
			return false;
		if (sensorName == null) {
			if (other.sensorName != null)
				return false;
		} else if (!sensorName.equals(other.sensorName))
			return false;
		if (valueMappings == null) {
			if (other.valueMappings != null)
				return false;
		} else if (!valueMappings.equals(other.valueMappings))
			return false;
		return true;
	}

	@Override
	public IShimmer getMote() {
		return mote;
	}
	
	

}
